module Table where

data Table a = Table (String -> a)
instance Show (Table a) where
    show x = "Table"

initialTable errorMessage = Table (\x -> error (errorMessage ++ show x))
updateTable (Table table) name (t, offset) = Table (\x -> if x == name then (t, offset) else table x)
contentTable (Table table) name = table name
offsetTable t name = snd $ contentTable t name
